program ecology;

{$APPTYPE CONSOLE}

const 
  nmax = 1000000;
  inf = maxint;

var 
  n, l, i, j, s, mins, y, miny: integer;
  a: array[0..nmax] of integer;
  
procedure exchg(apar, bpar: integer);
var tl: integer;
begin
  tl := a[apar]; a[apar] := a[bpar]; a[bpar] := tl;
end;

procedure restore_reg(apar, bpar: integer);
var jl: integer;
begin
  repeat
    jl := apar;
    if (2*apar <= bpar) and (a[2*apar] > a[jl]) then jl := 2*apar;
    if (2*apar+1 <= bpar) and (a[2*apar+1] > a[jl]) then jl := 2*apar+1;
    if (apar <> jl) then
    begin
      exchg(apar,  jl);
      apar := jl;
      jl := -1;
    end;
  until apar = jl;
end;

begin
  assignfile (input, 'input.txt'); reset (input);
  assignfile (output, 'output.txt'); rewrite (output);

  read (n, l);
  for i := 1 to n do read (a[i]);

  s := 0;
  for i := 1 to n do 
  begin
    a[i] := a[i] mod l;
    inc(s, a[i]);
  end;

  for i := n downto 1 do restore_reg(i, n);
  for i := n downto 2 do 
  begin
    exchg(1, i);
    restore_reg(1, i-1);
  end;

  mins := inf; miny := -1;

  i := n; y := 0;
  while i >= 1 do 
  begin
    if (s < mins) then 
    begin
      mins := s;
      miny := y;
    end;

    j := i;
    while (j > 1) and (a[j - 1] = a[i]) do dec(j);

    inc(s, n*(l - a[i] - y) - (i - j + 1)*l);    
    inc(y, l - a[i] - y);

    i := j - 1;
  end;

  if (s < mins) then miny := y;

  writeln(miny);

  closefile (input); closefile (output);
end.